Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 74430)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -3150,187 +2747,29 @@
         ERR("fileref was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
-    InitializeListHead(&streamlist);
-    
-    ExAcquireResourceSharedLite(&fileref->fcb->Vcb->tree_lock, TRUE);
-    ExAcquireResourceSharedLite(fileref->fcb->Header.Resource, TRUE);
-    
+
     suf.Buffer = datasuf;
     suf.Length = suf.MaximumLength = wcslen(datasuf) * sizeof(WCHAR);
     
-    searchkey.obj_id = fileref->fcb->inode;
-    searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = 0;
-
-    Status = find_item(fileref->fcb->Vcb, fileref->fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
+    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY)
+        reqsize = sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR);
+    else
+        reqsize = 0;
     
-    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY) {
-        si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-        if (!si) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        si->name.Length = si->name.MaximumLength = 0;
-        si->name.Buffer = NULL;
-        si->size = fileref->fcb->inode_item.st_size;
-        si->ignore = FALSE;
-        
-        InsertTailList(&streamlist, &si->list_entry);
-    }
+    ExAcquireResourceSharedLite(&fileref->fcb->nonpaged->dir_children_lock, TRUE);
     
-    do {
-        if (tp.item->key.obj_id == fileref->fcb->inode && tp.item->key.obj_type == TYPE_XATTR_ITEM) {
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
-            } else {
-                ULONG len = tp.item->size;
-                DIR_ITEM* xa = (DIR_ITEM*)tp.item->data;
-                ULONG stringlen;
-                
-                do {
-                    if (len < sizeof(DIR_ITEM) || len < sizeof(DIR_ITEM) - 1 + xa->m + xa->n) {
-                        ERR("(%llx,%x,%llx) was truncated\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
-                        break;
-                    }
-                    
-                    if (xa->n > strlen(xapref) && RtlCompareMemory(xa->name, xapref, strlen(xapref)) == strlen(xapref) &&
-                        (tp.item->key.offset != EA_DOSATTRIB_HASH || xa->n != strlen(EA_DOSATTRIB) || RtlCompareMemory(xa->name, EA_DOSATTRIB, xa->n) != xa->n) &&
-                        (tp.item->key.offset != EA_EA_HASH || xa->n != strlen(EA_EA) || RtlCompareMemory(xa->name, EA_EA, xa->n) != xa->n)
-                    ) {
-                        Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, &xa->name[strlen(xapref)], xa->n - strlen(xapref));
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
-                            goto end;
-                        }
-                        
-                        si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-                        if (!si) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        si->name.Buffer = ExAllocatePoolWithTag(PagedPool, stringlen, ALLOC_TAG);
-                        if (!si->name.Buffer) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(si);
-                            goto end;
-                        }
-                            
-                        Status = RtlUTF8ToUnicodeN(si->name.Buffer, stringlen, &stringlen, &xa->name[strlen(xapref)], xa->n - strlen(xapref));
-                        
-                        if (!NT_SUCCESS(Status)) {
-                            ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
-                            ExFreePool(si->name.Buffer);
-                            ExFreePool(si);
-                            goto end;
-                        }
-                        
-                        si->name.Length = si->name.MaximumLength = stringlen;
-                        
-                        si->size = xa->m;
-                        
-                        si->ignore = FALSE;
-                        
-                        TRACE("stream name = %.*S (length = %u)\n", si->name.Length / sizeof(WCHAR), si->name.Buffer, si->name.Length / sizeof(WCHAR));
-                        
-                        InsertTailList(&streamlist, &si->list_entry);
-                    }
-                    
-                    len -= sizeof(DIR_ITEM) - sizeof(char) + xa->n + xa->m;
-                    xa = (DIR_ITEM*)&xa->name[xa->n + xa->m]; // FIXME - test xattr hash collisions work
-                } while (len > 0);
-            }
-        }
+    le = fileref->fcb->dir_children_index.Flink;
+    while (le != &fileref->fcb->dir_children_index) {
+        dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
         
-        b = find_next_item(fileref->fcb->Vcb, &tp, &next_tp, FALSE, Irp);
-        if (b) {
-            tp = next_tp;
-            
-            if (next_tp.item->key.obj_id > fileref->fcb->inode || next_tp.item->key.obj_type > TYPE_XATTR_ITEM)
-                break;
-        }
-    } while (b);
-    
-    ExAcquireResourceSharedLite(&fileref->nonpaged->children_lock, TRUE);
-    
-    le = fileref->children.Flink;
-    while (le != &fileref->children) {
-        file_ref* fr = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (fr->fcb && fr->fcb->ads) {
-            LIST_ENTRY* le2 = streamlist.Flink;
-            BOOL found = FALSE;
-            
-            while (le2 != &streamlist) {
-                si = CONTAINING_RECORD(le2, stream_info, list_entry);
-                
-                if (si && si->name.Buffer && si->name.Length == fr->filepart.Length &&
-                    RtlCompareMemory(si->name.Buffer, fr->filepart.Buffer, si->name.Length) == si->name.Length) {
-                    
-                    si->size = fr->fcb->adsdata.Length;
-                    si->ignore = fr->fcb->deleted;
-                    
-                    found = TRUE;
-                    break;
-                }
-                
-                le2 = le2->Flink;
-            }
-            
-            if (!found && !fr->fcb->deleted) {
-                si = ExAllocatePoolWithTag(PagedPool, sizeof(stream_info), ALLOC_TAG);
-                if (!si) {
-                    ERR("out of memory\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    goto end;
-                }
-                
-                si->name.Length = si->name.MaximumLength = fr->filepart.Length;
-                
-                si->name.Buffer = ExAllocatePoolWithTag(PagedPool, si->name.MaximumLength, ALLOC_TAG);
-                if (!si->name.Buffer) {
-                    ERR("out of memory\n");
-                    Status = STATUS_INSUFFICIENT_RESOURCES;
-                    ExFreePool(si);
-                    goto end;
-                }
-                
-                RtlCopyMemory(si->name.Buffer, fr->filepart.Buffer, fr->filepart.Length);
-                
-                si->size = fr->fcb->adsdata.Length;
-                si->ignore = FALSE;
-                
-                InsertTailList(&streamlist, &si->list_entry);
-            }
-        }
-        
-        le = le->Flink;
-    }
-    
-    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
-    
-    reqsize = 0;
-    
-    le = streamlist.Flink;
-    while (le != &streamlist) {
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
-        
-        if (!si->ignore) {
+        if (dc->index == 0) {
             reqsize = sector_align(reqsize, sizeof(LONGLONG));
-            reqsize += sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + si->name.Length;
-        }
+            reqsize += sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + dc->name.Length;
+        } else
+            break;
 
         le = le->Flink;
-    }        
+    }
     
     TRACE("length = %i, reqsize = %u\n", *length, reqsize);
     
@@ -3342,37 +2781,54 @@
     entry = fsi;
     lastentry = NULL;
     
-    le = streamlist.Flink;
-    while (le != &streamlist) {
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
+    if (fileref->fcb->type != BTRFS_TYPE_DIRECTORY) {
+        ULONG off;
         
-        if (!si->ignore) {
+        entry->NextEntryOffset = 0;
+        entry->StreamNameLength = suf.Length + sizeof(WCHAR);
+        entry->StreamSize.QuadPart = fileref->fcb->inode_item.st_size;
+        entry->StreamAllocationSize.QuadPart = sector_align(fileref->fcb->inode_item.st_size, fileref->fcb->Vcb->superblock.sector_size);
+
+        entry->StreamName[0] = ':';
+        RtlCopyMemory(&entry->StreamName[1], suf.Buffer, suf.Length);
+        
+        off = sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR), sizeof(LONGLONG));
+
+        lastentry = entry;
+        entry = (FILE_STREAM_INFORMATION*)((UINT8*)entry + off);
+    }
+    
+    le = fileref->fcb->dir_children_index.Flink;
+    while (le != &fileref->fcb->dir_children_index) {
+        dir_child* dc = CONTAINING_RECORD(le, dir_child, list_entry_index);
+        
+        if (dc->index == 0) {
             ULONG off;
             
             entry->NextEntryOffset = 0;
-            entry->StreamNameLength = si->name.Length + suf.Length + sizeof(WCHAR);
-            entry->StreamSize.QuadPart = si->size;
+            entry->StreamNameLength = dc->name.Length + suf.Length + sizeof(WCHAR);
             
-            if (le == streamlist.Flink)
-                entry->StreamAllocationSize.QuadPart = sector_align(fileref->fcb->inode_item.st_size, fileref->fcb->Vcb->superblock.sector_size);
+            if (dc->fileref)
+                entry->StreamSize.QuadPart = dc->fileref->fcb->adsdata.Length;
             else
-                entry->StreamAllocationSize.QuadPart = si->size;
+                entry->StreamSize.QuadPart = dc->size;
             
+            entry->StreamAllocationSize.QuadPart = entry->StreamSize.QuadPart;
+            
             entry->StreamName[0] = ':';
             
-            if (si->name.Length > 0)
-                RtlCopyMemory(&entry->StreamName[1], si->name.Buffer, si->name.Length);
+            RtlCopyMemory(&entry->StreamName[1], dc->name.Buffer, dc->name.Length);
+            RtlCopyMemory(&entry->StreamName[1 + (dc->name.Length / sizeof(WCHAR))], suf.Buffer, suf.Length);
             
-            RtlCopyMemory(&entry->StreamName[1 + (si->name.Length / sizeof(WCHAR))], suf.Buffer, suf.Length);
-            
             if (lastentry)
                 lastentry->NextEntryOffset = (UINT8*)entry - (UINT8*)lastentry;
             
-            off = sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + si->name.Length, sizeof(LONGLONG));
+            off = sector_align(sizeof(FILE_STREAM_INFORMATION) - sizeof(WCHAR) + suf.Length + sizeof(WCHAR) + dc->name.Length, sizeof(LONGLONG));
 
             lastentry = entry;
             entry = (FILE_STREAM_INFORMATION*)((UINT8*)entry + off);
-        }
+        } else
+            break;
         
         le = le->Flink;
     }
@@ -3382,19 +2838,8 @@
     Status = STATUS_SUCCESS;
     
 end:
-    while (!IsListEmpty(&streamlist)) {
-        le = RemoveHeadList(&streamlist);
-        si = CONTAINING_RECORD(le, stream_info, list_entry);
-        
-        if (si->name.Buffer)
-            ExFreePool(si->name.Buffer);
-        
-        ExFreePool(si);
-    }
+    ExReleaseResourceLite(&fileref->fcb->nonpaged->dir_children_lock);
     
-    ExReleaseResourceLite(fileref->fcb->Header.Resource);
-    ExReleaseResourceLite(&fileref->fcb->Vcb->tree_lock);
-    
     return Status;
 }
 
@@ -3407,7 +2852,7 @@
     fsli->NumberOfAccessibleLinks = fcb->inode_item.st_nlink;
     fsli->TotalNumberOfLinks = fcb->inode_item.st_nlink;
     fsli->DeletePending = fileref ? fileref->delete_on_close : FALSE;
-    fsli->Directory = fcb->type == BTRFS_TYPE_DIRECTORY ? TRUE : FALSE;
+    fsli->Directory = (!fcb->ads && fcb->type == BTRFS_TYPE_DIRECTORY) ? TRUE : FALSE;
     
     *length -= sizeof(FILE_STANDARD_LINK_INFORMATION);
     
@@ -3415,291 +2860,13 @@
 }
 #endif /* __REACTOS__ */
 
-typedef struct {
-    UNICODE_STRING name;
-    UINT64 inode;
-    LIST_ENTRY list_entry;
-} name_bit;
-
-static NTSTATUS get_subvol_path(device_extension* Vcb, root* subvol, PIRP Irp) {
-    KEY searchkey;
-    traverse_ptr tp;
-    NTSTATUS Status;
-    LIST_ENTRY* le;
-    root* parsubvol;
-    UNICODE_STRING dirpath;
-    ROOT_REF* rr;
-    ULONG namelen;
-    
-    // FIXME - add subvol->parent field
-    
-    if (subvol == Vcb->root_fileref->fcb->subvol) {
-        subvol->path.Length = subvol->path.MaximumLength = sizeof(WCHAR);
-        subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-        subvol->path.Buffer[0] = '\\';
-        return STATUS_SUCCESS;
-    }
-    
-    searchkey.obj_id = subvol->id;
-    searchkey.obj_type = TYPE_ROOT_BACKREF;
-    searchkey.offset = 0xffffffffffffffff;
-    
-    Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        return Status;
-    }
-    
-    if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) { // top subvol
-        subvol->path.Length = subvol->path.MaximumLength = sizeof(WCHAR);
-        subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-        subvol->path.Buffer[0] = '\\';
-        return STATUS_SUCCESS;
-    }
-    
-    if (tp.item->size < sizeof(ROOT_REF)) {
-        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF));
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    rr = (ROOT_REF*)tp.item->data;
-    
-    if (tp.item->size < sizeof(ROOT_REF) - 1 + rr->n) {
-        ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(ROOT_REF) - 1 + rr->n);
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    le = Vcb->roots.Flink;
-
-    parsubvol = NULL;
-
-    while (le != &Vcb->roots) {
-        root* r2 = CONTAINING_RECORD(le, root, list_entry);
-        
-        if (r2->id == tp.item->key.offset) {
-            parsubvol = r2;
-            break;
-        }
-        
-        le = le->Flink;
-    }
-    
-    if (!parsubvol) {
-        ERR("unable to find subvol %llx\n", tp.item->key.offset);
-        return STATUS_INTERNAL_ERROR;
-    }
-    
-    // FIXME - recursion
-
-    Status = get_inode_dir_path(Vcb, parsubvol, rr->dir, &dirpath, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("get_inode_dir_path returned %08x\n", Status);
-        return Status;
-    }
-    
-    Status = RtlUTF8ToUnicodeN(NULL, 0, &namelen, rr->name, rr->n);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (namelen == 0) {
-        ERR("length was 0\n");
-        Status = STATUS_INTERNAL_ERROR;
-        goto end;
-    }
-    
-    subvol->path.Length = subvol->path.MaximumLength = dirpath.Length + namelen;
-    subvol->path.Buffer = ExAllocatePoolWithTag(PagedPool, subvol->path.Length, ALLOC_TAG);
-    
-    if (!subvol->path.Buffer) {  
-        ERR("out of memory\n");
-        
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(subvol->path.Buffer, dirpath.Buffer, dirpath.Length);
-        
-    Status = RtlUTF8ToUnicodeN(&subvol->path.Buffer[dirpath.Length / sizeof(WCHAR)], namelen, &namelen, rr->name, rr->n);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-        goto end;
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    if (dirpath.Buffer)
-        ExFreePool(dirpath.Buffer);
-    
-    if (!NT_SUCCESS(Status) && subvol->path.Buffer) {
-        ExFreePool(subvol->path.Buffer);
-        subvol->path.Buffer = NULL;
-    }
-    
-    return Status;
-}
-
-static NTSTATUS get_inode_dir_path(device_extension* Vcb, root* subvol, UINT64 inode, PUNICODE_STRING us, PIRP Irp) {
-    KEY searchkey;
-    NTSTATUS Status;
-    UINT64 in;
-    traverse_ptr tp;
-    LIST_ENTRY name_trail, *le;
-    UINT16 levels = 0;
-    UINT32 namelen = 0;
-    WCHAR* usbuf;
-    
-    InitializeListHead(&name_trail);
-    
-    in = inode;
-    
-    // FIXME - start with subvol prefix
-    if (!subvol->path.Buffer) {
-        Status = get_subvol_path(Vcb, subvol, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("get_subvol_path returned %08x\n", Status);
-            return Status;
-        }
-    }
-    
-    while (in != subvol->root_item.objid) {
-        searchkey.obj_id = in;
-        searchkey.obj_type = TYPE_INODE_EXTREF;
-        searchkey.offset = 0xffffffffffffffff;
-        
-        Status = find_item(Vcb, subvol, &tp, &searchkey, FALSE, Irp);
-        if (!NT_SUCCESS(Status)) {
-            ERR("error - find_item returned %08x\n", Status);
-            goto end;
-        }
-        
-        if (tp.item->key.obj_id != searchkey.obj_id) {
-            ERR("could not find INODE_REF for inode %llx in subvol %llx\n", searchkey.obj_id, subvol->id);
-            Status = STATUS_INTERNAL_ERROR;
-            goto end;
-        }
-        
-        if (tp.item->key.obj_type == TYPE_INODE_REF) {
-            INODE_REF* ir = (INODE_REF*)tp.item->data;
-            name_bit* nb;
-            ULONG len;
-            
-            if (tp.item->size < sizeof(INODE_REF)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(INODE_REF));
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            if (tp.item->size < sizeof(INODE_REF) - 1 + ir->n) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(INODE_REF) - 1 + ir->n);
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            nb = ExAllocatePoolWithTag(PagedPool, sizeof(name_bit), ALLOC_TAG);
-            if (!nb) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
-            }
-            
-            nb->name.Buffer = NULL;
-            
-            InsertTailList(&name_trail, &nb->list_entry);
-            levels++;
-            
-            Status = RtlUTF8ToUnicodeN(NULL, 0, &len, ir->name, ir->n);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-                goto end;
-            }
-            
-            if (len == 0) {
-                ERR("length was 0\n");
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            nb->name.Length = nb->name.MaximumLength = len;
-            
-            nb->name.Buffer = ExAllocatePoolWithTag(PagedPool, nb->name.Length, ALLOC_TAG);
-            if (!nb->name.Buffer) {  
-                ERR("out of memory\n");
-                
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
-            }
-                
-            Status = RtlUTF8ToUnicodeN(nb->name.Buffer, len, &len, ir->name, ir->n);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUTF8ToUnicodeN returned %08x\n", Status);
-                goto end;
-            }
-            
-            in = tp.item->key.offset;
-            namelen += nb->name.Length;
-            
-//         } else if (tp.item->key.obj_type == TYPE_INODE_EXTREF) {
-//             // FIXME
-        } else {
-            ERR("could not find INODE_REF for inode %llx in subvol %llx\n", searchkey.obj_id, subvol->id);
-            Status = STATUS_INTERNAL_ERROR;
-            goto end;
-        }
-    }
-    
-    namelen += (levels + 1) * sizeof(WCHAR);
-    
-    us->Length = us->MaximumLength = namelen;
-    us->Buffer = ExAllocatePoolWithTag(PagedPool, us->Length, ALLOC_TAG);
-    
-    if (!us->Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    us->Buffer[0] = '\\';
-    usbuf = &us->Buffer[1];
-    
-    le = name_trail.Blink;
-    while (le != &name_trail) {
-        name_bit* nb = CONTAINING_RECORD(le, name_bit, list_entry);
-        
-        RtlCopyMemory(usbuf, nb->name.Buffer, nb->name.Length);
-        usbuf += nb->name.Length / sizeof(WCHAR);
-        
-        usbuf[0] = '\\';
-        usbuf++;
-        
-        le = le->Blink;
-    }
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    while (!IsListEmpty(&name_trail)) {
-        name_bit* nb = CONTAINING_RECORD(name_trail.Flink, name_bit, list_entry);
-        
-        if (nb->name.Buffer)
-            ExFreePool(nb->name.Buffer);
-        
-        RemoveEntryList(&nb->list_entry);
-        
-        ExFreePool(nb);
-    }
-
-    return Status;
-}
-
 NTSTATUS open_fileref_by_inode(device_extension* Vcb, root* subvol, UINT64 inode, file_ref** pfr, PIRP Irp) {
     NTSTATUS Status;
     fcb* fcb;
-    hardlink* hl;
+    UINT64 parent = 0;
+    UNICODE_STRING name;
+    BOOL hl_alloc = FALSE;
     file_ref *parfr, *fr;
-    dir_child* dc = NULL;
     
     Status = open_fcb(Vcb, subvol, inode, 0, NULL, NULL, &fcb, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
